// This file is part of the SV-Benchmarks collection of verification tasks:
// https://gitlab.com/sosy-lab/benchmarking/sv-benchmarks
//
// SPDX-FileCopyrightText: 2020 Aman Goel
// SPDX-FileCopyrightText: 2022 The SV-Benchmarks Community
//
// SPDX-License-Identifier: GPL-3.0-or-later

// This C program is converted from Btor2 by Btor2C version sha1:a0fa249
//   with arguments: { architecture=64, lazy_modulo=true, use_memmove=false, unroll_inner_loops=false, shortest_type=true, diff_type=true, decimal_constant=true, zero_init=false, sra_extend_sign=true }
// Comments from the original Btor2 file:
// ; source: https://github.com/aman-goel/avr/tree/92362931700b66684418a991d018c9fbdbebc06f/tests
// ; BTOR description generated by Yosys 0.9+431 (git sha1 4a3b5437, clang 4.0.1-6 -fPIC -Os) for module main.
extern unsigned char __VERIFIER_nondet_uchar();
extern unsigned short __VERIFIER_nondet_ushort();
extern unsigned int __VERIFIER_nondet_uint();
extern unsigned long __VERIFIER_nondet_ulong();
extern void abort(void);
extern void __assert_fail(const char *, const char *, unsigned int, const char *);
void reach_error() { __assert_fail("0", "sw_ball2001.c", 0, "reach_error"); }
void __VERIFIER_assert(int cond) { if (!(cond)) { ERROR: { reach_error(); abort(); } } }
void assume_abort_if_not(int cond) { if (!cond) { abort(); } }
int main() {
  // Defining sorts ...
  typedef unsigned char SORT_1;  // BV with 1 bits
  const SORT_1 mask_SORT_1 = (SORT_1)-1 >> (sizeof(SORT_1) * 8 - 1);
  const SORT_1 msb_SORT_1 = (SORT_1)1 << (1 - 1);
  typedef unsigned char SORT_31;  // BV with 3 bits
  const SORT_31 mask_SORT_31 = (SORT_31)-1 >> (sizeof(SORT_31) * 8 - 3);
  const SORT_31 msb_SORT_31 = (SORT_31)1 << (3 - 1);
  // Initializing constants ...
  const SORT_1 var_3 = 0;
  const SORT_1 var_9 = 1;
  const SORT_31 var_37 = 0;
  const SORT_31 var_226 = 1;
  // Collecting input declarations ...
  SORT_1 input_2;
  // Collecting state declarations ...
  SORT_1 state_4 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_1 state_13 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_1 state_15 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_1 state_17 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_1 state_19 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_1 state_21 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_1 state_23 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_1 state_25 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_1 state_27 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_1 state_29 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  SORT_31 state_32 = __VERIFIER_nondet_uchar() & mask_SORT_31;
  SORT_31 state_33 = __VERIFIER_nondet_uchar() & mask_SORT_31;
  SORT_31 state_34 = __VERIFIER_nondet_uchar() & mask_SORT_31;
  SORT_31 state_35 = __VERIFIER_nondet_uchar() & mask_SORT_31;
  // Initializing states ...
  SORT_1 init_5_arg_1 = var_3;
  state_4 = init_5_arg_1;
  SORT_1 init_14_arg_1 = var_9;
  state_13 = init_14_arg_1;
  SORT_1 init_16_arg_1 = var_3;
  state_15 = init_16_arg_1;
  SORT_1 init_18_arg_1 = var_3;
  state_17 = init_18_arg_1;
  SORT_1 init_20_arg_1 = var_3;
  state_19 = init_20_arg_1;
  SORT_1 init_22_arg_1 = var_3;
  state_21 = init_22_arg_1;
  SORT_1 init_24_arg_1 = var_3;
  state_23 = init_24_arg_1;
  SORT_1 init_26_arg_1 = var_3;
  state_25 = init_26_arg_1;
  SORT_1 init_28_arg_1 = var_3;
  state_27 = init_28_arg_1;
  SORT_1 init_30_arg_1 = var_9;
  state_29 = init_30_arg_1;
  for (;;) {
    // Getting external input values ...
    input_2 = __VERIFIER_nondet_uchar();
    // Assuming invariants ...
    // Asserting properties ...
    SORT_1 var_6_arg_0 = state_4;
    SORT_1 var_6 = ~var_6_arg_0;
    SORT_1 var_10_arg_0 = var_6;
    SORT_1 var_10 = ~var_10_arg_0;
    SORT_1 var_11_arg_0 = var_9;
    SORT_1 var_11_arg_1 = var_10;
    SORT_1 var_11 = var_11_arg_0 & var_11_arg_1;
    var_11 = var_11 & mask_SORT_1;
    SORT_1 bad_12_arg_0 = var_11;
    __VERIFIER_assert(!(bad_12_arg_0));
    // Computing next states ...
    SORT_31 var_38_arg_0 = state_35;
    SORT_31 var_38_arg_1 = var_37;
    SORT_1 var_38 = var_38_arg_0 != var_38_arg_1;
    SORT_1 var_39_arg_0 = state_25;
    SORT_1 var_39_arg_1 = var_38;
    SORT_1 var_39 = var_39_arg_0 & var_39_arg_1;
    SORT_1 var_40_arg_0 = state_4;
    SORT_1 var_40_arg_1 = var_39;
    SORT_1 var_40 = var_40_arg_0 | var_40_arg_1;
    SORT_1 var_41_arg_0 = state_29;
    SORT_1 var_41_arg_1 = var_40;
    SORT_1 var_41_arg_2 = state_4;
    SORT_1 var_41 = var_41_arg_0 ? var_41_arg_1 : var_41_arg_2;
    SORT_1 next_42_arg_1 = var_41;
    SORT_1 var_43_arg_0 = state_29;
    SORT_1 var_43_arg_1 = var_3;
    SORT_1 var_43_arg_2 = state_13;
    SORT_1 var_43 = var_43_arg_0 ? var_43_arg_1 : var_43_arg_2;
    var_43 = var_43 & mask_SORT_1;
    SORT_1 next_44_arg_1 = var_43;
    SORT_31 var_45_arg_0 = state_33;
    SORT_31 var_45_arg_1 = state_34;
    SORT_1 var_45 = var_45_arg_0 != var_45_arg_1;
    SORT_1 var_46_arg_0 = state_23;
    SORT_1 var_46_arg_1 = var_45;
    SORT_1 var_46 = var_46_arg_0 & var_46_arg_1;
    SORT_1 var_47_arg_0 = state_13;
    SORT_1 var_47_arg_1 = var_46;
    SORT_1 var_47 = var_47_arg_0 | var_47_arg_1;
    SORT_1 var_48_arg_0 = state_29;
    SORT_1 var_48_arg_1 = var_47;
    SORT_1 var_48_arg_2 = state_15;
    SORT_1 var_48 = var_48_arg_0 ? var_48_arg_1 : var_48_arg_2;
    var_48 = var_48 & mask_SORT_1;
    SORT_1 next_49_arg_1 = var_48;
    SORT_1 var_50_arg_0 = state_29;
    SORT_1 var_50_arg_1 = state_15;
    SORT_1 var_50_arg_2 = state_17;
    SORT_1 var_50 = var_50_arg_0 ? var_50_arg_1 : var_50_arg_2;
    var_50 = var_50 & mask_SORT_1;
    SORT_1 next_51_arg_1 = var_50;
    SORT_31 var_52_arg_0 = state_32;
    SORT_31 var_52_arg_1 = var_37;
    SORT_1 var_52 = var_52_arg_0 != var_52_arg_1;
    SORT_1 var_53_arg_0 = state_17;
    SORT_1 var_53_arg_1 = var_52;
    SORT_1 var_53 = var_53_arg_0 & var_53_arg_1;
    SORT_1 var_54_arg_0 = state_29;
    SORT_1 var_54_arg_1 = var_53;
    SORT_1 var_54_arg_2 = state_19;
    SORT_1 var_54 = var_54_arg_0 ? var_54_arg_1 : var_54_arg_2;
    var_54 = var_54 & mask_SORT_1;
    SORT_1 next_55_arg_1 = var_54;
    SORT_1 var_56_arg_0 = state_29;
    SORT_1 var_56_arg_1 = state_19;
    SORT_1 var_56_arg_2 = state_21;
    SORT_1 var_56 = var_56_arg_0 ? var_56_arg_1 : var_56_arg_2;
    SORT_1 next_57_arg_1 = var_56;
    SORT_31 var_58_arg_0 = state_32;
    SORT_31 var_58_arg_1 = var_37;
    SORT_1 var_58 = var_58_arg_0 == var_58_arg_1;
    SORT_1 var_59_arg_0 = state_17;
    SORT_1 var_59_arg_1 = var_58;
    SORT_1 var_59 = var_59_arg_0 & var_59_arg_1;
    SORT_1 var_60_arg_0 = state_21;
    SORT_1 var_60_arg_1 = var_59;
    SORT_1 var_60 = var_60_arg_0 | var_60_arg_1;
    SORT_1 var_61_arg_0 = state_29;
    SORT_1 var_61_arg_1 = var_60;
    SORT_1 var_61_arg_2 = state_23;
    SORT_1 var_61 = var_61_arg_0 ? var_61_arg_1 : var_61_arg_2;
    var_61 = var_61 & mask_SORT_1;
    SORT_1 next_62_arg_1 = var_61;
    SORT_31 var_63_arg_0 = state_33;
    SORT_31 var_63_arg_1 = state_34;
    SORT_1 var_63 = var_63_arg_0 == var_63_arg_1;
    SORT_1 var_64_arg_0 = state_23;
    SORT_1 var_64_arg_1 = var_63;
    SORT_1 var_64 = var_64_arg_0 & var_64_arg_1;
    SORT_1 var_65_arg_0 = state_29;
    SORT_1 var_65_arg_1 = var_64;
    SORT_1 var_65_arg_2 = state_25;
    SORT_1 var_65 = var_65_arg_0 ? var_65_arg_1 : var_65_arg_2;
    SORT_1 next_66_arg_1 = var_65;
    SORT_31 var_67_arg_0 = state_35;
    SORT_31 var_67_arg_1 = var_37;
    SORT_1 var_67 = var_67_arg_0 == var_67_arg_1;
    SORT_1 var_68_arg_0 = state_25;
    SORT_1 var_68_arg_1 = var_67;
    SORT_1 var_68 = var_68_arg_0 & var_68_arg_1;
    SORT_1 var_69_arg_0 = state_27;
    SORT_1 var_69_arg_1 = var_68;
    SORT_1 var_69 = var_69_arg_0 | var_69_arg_1;
    SORT_1 var_70_arg_0 = state_29;
    SORT_1 var_70_arg_1 = var_69;
    SORT_1 var_70_arg_2 = state_27;
    SORT_1 var_70 = var_70_arg_0 ? var_70_arg_1 : var_70_arg_2;
    SORT_1 next_71_arg_1 = var_70;
    SORT_1 var_72_arg_0 = state_15;
    SORT_1 var_72 = ~var_72_arg_0;
    SORT_1 var_73_arg_0 = state_13;
    SORT_1 var_73_arg_1 = var_72;
    SORT_1 var_73 = var_73_arg_0 & var_73_arg_1;
    SORT_1 var_74_arg_0 = state_17;
    SORT_1 var_74 = ~var_74_arg_0;
    SORT_1 var_75_arg_0 = var_73;
    SORT_1 var_75_arg_1 = var_74;
    SORT_1 var_75 = var_75_arg_0 & var_75_arg_1;
    SORT_1 var_76_arg_0 = state_19;
    SORT_1 var_76 = ~var_76_arg_0;
    SORT_1 var_77_arg_0 = var_75;
    SORT_1 var_77_arg_1 = var_76;
    SORT_1 var_77 = var_77_arg_0 & var_77_arg_1;
    SORT_1 var_78_arg_0 = state_21;
    SORT_1 var_78 = ~var_78_arg_0;
    SORT_1 var_79_arg_0 = var_77;
    SORT_1 var_79_arg_1 = var_78;
    SORT_1 var_79 = var_79_arg_0 & var_79_arg_1;
    SORT_1 var_80_arg_0 = state_23;
    SORT_1 var_80 = ~var_80_arg_0;
    SORT_1 var_81_arg_0 = var_79;
    SORT_1 var_81_arg_1 = var_80;
    SORT_1 var_81 = var_81_arg_0 & var_81_arg_1;
    SORT_1 var_82_arg_0 = state_25;
    SORT_1 var_82 = ~var_82_arg_0;
    SORT_1 var_83_arg_0 = var_81;
    SORT_1 var_83_arg_1 = var_82;
    SORT_1 var_83 = var_83_arg_0 & var_83_arg_1;
    SORT_1 var_84_arg_0 = state_4;
    SORT_1 var_84 = ~var_84_arg_0;
    SORT_1 var_85_arg_0 = var_83;
    SORT_1 var_85_arg_1 = var_84;
    SORT_1 var_85 = var_85_arg_0 & var_85_arg_1;
    SORT_1 var_86_arg_0 = state_27;
    SORT_1 var_86 = ~var_86_arg_0;
    SORT_1 var_87_arg_0 = var_85;
    SORT_1 var_87_arg_1 = var_86;
    SORT_1 var_87 = var_87_arg_0 & var_87_arg_1;
    SORT_1 var_88_arg_0 = state_13;
    SORT_1 var_88 = ~var_88_arg_0;
    SORT_1 var_89_arg_0 = var_88;
    SORT_1 var_89_arg_1 = state_15;
    SORT_1 var_89 = var_89_arg_0 & var_89_arg_1;
    SORT_1 var_90_arg_0 = state_17;
    SORT_1 var_90 = ~var_90_arg_0;
    SORT_1 var_91_arg_0 = var_89;
    SORT_1 var_91_arg_1 = var_90;
    SORT_1 var_91 = var_91_arg_0 & var_91_arg_1;
    SORT_1 var_92_arg_0 = state_19;
    SORT_1 var_92 = ~var_92_arg_0;
    SORT_1 var_93_arg_0 = var_91;
    SORT_1 var_93_arg_1 = var_92;
    SORT_1 var_93 = var_93_arg_0 & var_93_arg_1;
    SORT_1 var_94_arg_0 = state_21;
    SORT_1 var_94 = ~var_94_arg_0;
    SORT_1 var_95_arg_0 = var_93;
    SORT_1 var_95_arg_1 = var_94;
    SORT_1 var_95 = var_95_arg_0 & var_95_arg_1;
    SORT_1 var_96_arg_0 = state_23;
    SORT_1 var_96 = ~var_96_arg_0;
    SORT_1 var_97_arg_0 = var_95;
    SORT_1 var_97_arg_1 = var_96;
    SORT_1 var_97 = var_97_arg_0 & var_97_arg_1;
    SORT_1 var_98_arg_0 = state_25;
    SORT_1 var_98 = ~var_98_arg_0;
    SORT_1 var_99_arg_0 = var_97;
    SORT_1 var_99_arg_1 = var_98;
    SORT_1 var_99 = var_99_arg_0 & var_99_arg_1;
    SORT_1 var_100_arg_0 = state_4;
    SORT_1 var_100 = ~var_100_arg_0;
    SORT_1 var_101_arg_0 = var_99;
    SORT_1 var_101_arg_1 = var_100;
    SORT_1 var_101 = var_101_arg_0 & var_101_arg_1;
    SORT_1 var_102_arg_0 = state_27;
    SORT_1 var_102 = ~var_102_arg_0;
    SORT_1 var_103_arg_0 = var_101;
    SORT_1 var_103_arg_1 = var_102;
    SORT_1 var_103 = var_103_arg_0 & var_103_arg_1;
    SORT_1 var_104_arg_0 = var_87;
    SORT_1 var_104_arg_1 = var_103;
    SORT_1 var_104 = var_104_arg_0 | var_104_arg_1;
    SORT_1 var_105_arg_0 = state_13;
    SORT_1 var_105 = ~var_105_arg_0;
    SORT_1 var_106_arg_0 = state_15;
    SORT_1 var_106 = ~var_106_arg_0;
    SORT_1 var_107_arg_0 = var_105;
    SORT_1 var_107_arg_1 = var_106;
    SORT_1 var_107 = var_107_arg_0 & var_107_arg_1;
    SORT_1 var_108_arg_0 = var_107;
    SORT_1 var_108_arg_1 = state_17;
    SORT_1 var_108 = var_108_arg_0 & var_108_arg_1;
    SORT_1 var_109_arg_0 = state_19;
    SORT_1 var_109 = ~var_109_arg_0;
    SORT_1 var_110_arg_0 = var_108;
    SORT_1 var_110_arg_1 = var_109;
    SORT_1 var_110 = var_110_arg_0 & var_110_arg_1;
    SORT_1 var_111_arg_0 = state_21;
    SORT_1 var_111 = ~var_111_arg_0;
    SORT_1 var_112_arg_0 = var_110;
    SORT_1 var_112_arg_1 = var_111;
    SORT_1 var_112 = var_112_arg_0 & var_112_arg_1;
    SORT_1 var_113_arg_0 = state_23;
    SORT_1 var_113 = ~var_113_arg_0;
    SORT_1 var_114_arg_0 = var_112;
    SORT_1 var_114_arg_1 = var_113;
    SORT_1 var_114 = var_114_arg_0 & var_114_arg_1;
    SORT_1 var_115_arg_0 = state_25;
    SORT_1 var_115 = ~var_115_arg_0;
    SORT_1 var_116_arg_0 = var_114;
    SORT_1 var_116_arg_1 = var_115;
    SORT_1 var_116 = var_116_arg_0 & var_116_arg_1;
    SORT_1 var_117_arg_0 = state_4;
    SORT_1 var_117 = ~var_117_arg_0;
    SORT_1 var_118_arg_0 = var_116;
    SORT_1 var_118_arg_1 = var_117;
    SORT_1 var_118 = var_118_arg_0 & var_118_arg_1;
    SORT_1 var_119_arg_0 = state_27;
    SORT_1 var_119 = ~var_119_arg_0;
    SORT_1 var_120_arg_0 = var_118;
    SORT_1 var_120_arg_1 = var_119;
    SORT_1 var_120 = var_120_arg_0 & var_120_arg_1;
    SORT_1 var_121_arg_0 = var_104;
    SORT_1 var_121_arg_1 = var_120;
    SORT_1 var_121 = var_121_arg_0 | var_121_arg_1;
    SORT_1 var_122_arg_0 = state_13;
    SORT_1 var_122 = ~var_122_arg_0;
    SORT_1 var_123_arg_0 = state_15;
    SORT_1 var_123 = ~var_123_arg_0;
    SORT_1 var_124_arg_0 = var_122;
    SORT_1 var_124_arg_1 = var_123;
    SORT_1 var_124 = var_124_arg_0 & var_124_arg_1;
    SORT_1 var_125_arg_0 = state_17;
    SORT_1 var_125 = ~var_125_arg_0;
    SORT_1 var_126_arg_0 = var_124;
    SORT_1 var_126_arg_1 = var_125;
    SORT_1 var_126 = var_126_arg_0 & var_126_arg_1;
    SORT_1 var_127_arg_0 = var_126;
    SORT_1 var_127_arg_1 = state_19;
    SORT_1 var_127 = var_127_arg_0 & var_127_arg_1;
    SORT_1 var_128_arg_0 = state_21;
    SORT_1 var_128 = ~var_128_arg_0;
    SORT_1 var_129_arg_0 = var_127;
    SORT_1 var_129_arg_1 = var_128;
    SORT_1 var_129 = var_129_arg_0 & var_129_arg_1;
    SORT_1 var_130_arg_0 = state_23;
    SORT_1 var_130 = ~var_130_arg_0;
    SORT_1 var_131_arg_0 = var_129;
    SORT_1 var_131_arg_1 = var_130;
    SORT_1 var_131 = var_131_arg_0 & var_131_arg_1;
    SORT_1 var_132_arg_0 = state_25;
    SORT_1 var_132 = ~var_132_arg_0;
    SORT_1 var_133_arg_0 = var_131;
    SORT_1 var_133_arg_1 = var_132;
    SORT_1 var_133 = var_133_arg_0 & var_133_arg_1;
    SORT_1 var_134_arg_0 = state_4;
    SORT_1 var_134 = ~var_134_arg_0;
    SORT_1 var_135_arg_0 = var_133;
    SORT_1 var_135_arg_1 = var_134;
    SORT_1 var_135 = var_135_arg_0 & var_135_arg_1;
    SORT_1 var_136_arg_0 = state_27;
    SORT_1 var_136 = ~var_136_arg_0;
    SORT_1 var_137_arg_0 = var_135;
    SORT_1 var_137_arg_1 = var_136;
    SORT_1 var_137 = var_137_arg_0 & var_137_arg_1;
    SORT_1 var_138_arg_0 = var_121;
    SORT_1 var_138_arg_1 = var_137;
    SORT_1 var_138 = var_138_arg_0 | var_138_arg_1;
    SORT_1 var_139_arg_0 = state_13;
    SORT_1 var_139 = ~var_139_arg_0;
    SORT_1 var_140_arg_0 = state_15;
    SORT_1 var_140 = ~var_140_arg_0;
    SORT_1 var_141_arg_0 = var_139;
    SORT_1 var_141_arg_1 = var_140;
    SORT_1 var_141 = var_141_arg_0 & var_141_arg_1;
    SORT_1 var_142_arg_0 = state_17;
    SORT_1 var_142 = ~var_142_arg_0;
    SORT_1 var_143_arg_0 = var_141;
    SORT_1 var_143_arg_1 = var_142;
    SORT_1 var_143 = var_143_arg_0 & var_143_arg_1;
    SORT_1 var_144_arg_0 = state_19;
    SORT_1 var_144 = ~var_144_arg_0;
    SORT_1 var_145_arg_0 = var_143;
    SORT_1 var_145_arg_1 = var_144;
    SORT_1 var_145 = var_145_arg_0 & var_145_arg_1;
    SORT_1 var_146_arg_0 = var_145;
    SORT_1 var_146_arg_1 = state_21;
    SORT_1 var_146 = var_146_arg_0 & var_146_arg_1;
    SORT_1 var_147_arg_0 = state_23;
    SORT_1 var_147 = ~var_147_arg_0;
    SORT_1 var_148_arg_0 = var_146;
    SORT_1 var_148_arg_1 = var_147;
    SORT_1 var_148 = var_148_arg_0 & var_148_arg_1;
    SORT_1 var_149_arg_0 = state_25;
    SORT_1 var_149 = ~var_149_arg_0;
    SORT_1 var_150_arg_0 = var_148;
    SORT_1 var_150_arg_1 = var_149;
    SORT_1 var_150 = var_150_arg_0 & var_150_arg_1;
    SORT_1 var_151_arg_0 = state_4;
    SORT_1 var_151 = ~var_151_arg_0;
    SORT_1 var_152_arg_0 = var_150;
    SORT_1 var_152_arg_1 = var_151;
    SORT_1 var_152 = var_152_arg_0 & var_152_arg_1;
    SORT_1 var_153_arg_0 = state_27;
    SORT_1 var_153 = ~var_153_arg_0;
    SORT_1 var_154_arg_0 = var_152;
    SORT_1 var_154_arg_1 = var_153;
    SORT_1 var_154 = var_154_arg_0 & var_154_arg_1;
    SORT_1 var_155_arg_0 = var_138;
    SORT_1 var_155_arg_1 = var_154;
    SORT_1 var_155 = var_155_arg_0 | var_155_arg_1;
    SORT_1 var_156_arg_0 = state_13;
    SORT_1 var_156 = ~var_156_arg_0;
    SORT_1 var_157_arg_0 = state_15;
    SORT_1 var_157 = ~var_157_arg_0;
    SORT_1 var_158_arg_0 = var_156;
    SORT_1 var_158_arg_1 = var_157;
    SORT_1 var_158 = var_158_arg_0 & var_158_arg_1;
    SORT_1 var_159_arg_0 = state_17;
    SORT_1 var_159 = ~var_159_arg_0;
    SORT_1 var_160_arg_0 = var_158;
    SORT_1 var_160_arg_1 = var_159;
    SORT_1 var_160 = var_160_arg_0 & var_160_arg_1;
    SORT_1 var_161_arg_0 = state_19;
    SORT_1 var_161 = ~var_161_arg_0;
    SORT_1 var_162_arg_0 = var_160;
    SORT_1 var_162_arg_1 = var_161;
    SORT_1 var_162 = var_162_arg_0 & var_162_arg_1;
    SORT_1 var_163_arg_0 = state_21;
    SORT_1 var_163 = ~var_163_arg_0;
    SORT_1 var_164_arg_0 = var_162;
    SORT_1 var_164_arg_1 = var_163;
    SORT_1 var_164 = var_164_arg_0 & var_164_arg_1;
    SORT_1 var_165_arg_0 = var_164;
    SORT_1 var_165_arg_1 = state_23;
    SORT_1 var_165 = var_165_arg_0 & var_165_arg_1;
    SORT_1 var_166_arg_0 = state_25;
    SORT_1 var_166 = ~var_166_arg_0;
    SORT_1 var_167_arg_0 = var_165;
    SORT_1 var_167_arg_1 = var_166;
    SORT_1 var_167 = var_167_arg_0 & var_167_arg_1;
    SORT_1 var_168_arg_0 = state_4;
    SORT_1 var_168 = ~var_168_arg_0;
    SORT_1 var_169_arg_0 = var_167;
    SORT_1 var_169_arg_1 = var_168;
    SORT_1 var_169 = var_169_arg_0 & var_169_arg_1;
    SORT_1 var_170_arg_0 = state_27;
    SORT_1 var_170 = ~var_170_arg_0;
    SORT_1 var_171_arg_0 = var_169;
    SORT_1 var_171_arg_1 = var_170;
    SORT_1 var_171 = var_171_arg_0 & var_171_arg_1;
    SORT_1 var_172_arg_0 = var_155;
    SORT_1 var_172_arg_1 = var_171;
    SORT_1 var_172 = var_172_arg_0 | var_172_arg_1;
    SORT_1 var_173_arg_0 = state_13;
    SORT_1 var_173 = ~var_173_arg_0;
    SORT_1 var_174_arg_0 = state_15;
    SORT_1 var_174 = ~var_174_arg_0;
    SORT_1 var_175_arg_0 = var_173;
    SORT_1 var_175_arg_1 = var_174;
    SORT_1 var_175 = var_175_arg_0 & var_175_arg_1;
    SORT_1 var_176_arg_0 = state_17;
    SORT_1 var_176 = ~var_176_arg_0;
    SORT_1 var_177_arg_0 = var_175;
    SORT_1 var_177_arg_1 = var_176;
    SORT_1 var_177 = var_177_arg_0 & var_177_arg_1;
    SORT_1 var_178_arg_0 = state_19;
    SORT_1 var_178 = ~var_178_arg_0;
    SORT_1 var_179_arg_0 = var_177;
    SORT_1 var_179_arg_1 = var_178;
    SORT_1 var_179 = var_179_arg_0 & var_179_arg_1;
    SORT_1 var_180_arg_0 = state_21;
    SORT_1 var_180 = ~var_180_arg_0;
    SORT_1 var_181_arg_0 = var_179;
    SORT_1 var_181_arg_1 = var_180;
    SORT_1 var_181 = var_181_arg_0 & var_181_arg_1;
    SORT_1 var_182_arg_0 = state_23;
    SORT_1 var_182 = ~var_182_arg_0;
    SORT_1 var_183_arg_0 = var_181;
    SORT_1 var_183_arg_1 = var_182;
    SORT_1 var_183 = var_183_arg_0 & var_183_arg_1;
    SORT_1 var_184_arg_0 = var_183;
    SORT_1 var_184_arg_1 = state_25;
    SORT_1 var_184 = var_184_arg_0 & var_184_arg_1;
    SORT_1 var_185_arg_0 = state_4;
    SORT_1 var_185 = ~var_185_arg_0;
    SORT_1 var_186_arg_0 = var_184;
    SORT_1 var_186_arg_1 = var_185;
    SORT_1 var_186 = var_186_arg_0 & var_186_arg_1;
    SORT_1 var_187_arg_0 = state_27;
    SORT_1 var_187 = ~var_187_arg_0;
    SORT_1 var_188_arg_0 = var_186;
    SORT_1 var_188_arg_1 = var_187;
    SORT_1 var_188 = var_188_arg_0 & var_188_arg_1;
    SORT_1 var_189_arg_0 = var_172;
    SORT_1 var_189_arg_1 = var_188;
    SORT_1 var_189 = var_189_arg_0 | var_189_arg_1;
    SORT_1 var_190_arg_0 = state_13;
    SORT_1 var_190 = ~var_190_arg_0;
    SORT_1 var_191_arg_0 = state_15;
    SORT_1 var_191 = ~var_191_arg_0;
    SORT_1 var_192_arg_0 = var_190;
    SORT_1 var_192_arg_1 = var_191;
    SORT_1 var_192 = var_192_arg_0 & var_192_arg_1;
    SORT_1 var_193_arg_0 = state_17;
    SORT_1 var_193 = ~var_193_arg_0;
    SORT_1 var_194_arg_0 = var_192;
    SORT_1 var_194_arg_1 = var_193;
    SORT_1 var_194 = var_194_arg_0 & var_194_arg_1;
    SORT_1 var_195_arg_0 = state_19;
    SORT_1 var_195 = ~var_195_arg_0;
    SORT_1 var_196_arg_0 = var_194;
    SORT_1 var_196_arg_1 = var_195;
    SORT_1 var_196 = var_196_arg_0 & var_196_arg_1;
    SORT_1 var_197_arg_0 = state_21;
    SORT_1 var_197 = ~var_197_arg_0;
    SORT_1 var_198_arg_0 = var_196;
    SORT_1 var_198_arg_1 = var_197;
    SORT_1 var_198 = var_198_arg_0 & var_198_arg_1;
    SORT_1 var_199_arg_0 = state_23;
    SORT_1 var_199 = ~var_199_arg_0;
    SORT_1 var_200_arg_0 = var_198;
    SORT_1 var_200_arg_1 = var_199;
    SORT_1 var_200 = var_200_arg_0 & var_200_arg_1;
    SORT_1 var_201_arg_0 = state_25;
    SORT_1 var_201 = ~var_201_arg_0;
    SORT_1 var_202_arg_0 = var_200;
    SORT_1 var_202_arg_1 = var_201;
    SORT_1 var_202 = var_202_arg_0 & var_202_arg_1;
    SORT_1 var_203_arg_0 = var_202;
    SORT_1 var_203_arg_1 = state_4;
    SORT_1 var_203 = var_203_arg_0 & var_203_arg_1;
    SORT_1 var_204_arg_0 = state_27;
    SORT_1 var_204 = ~var_204_arg_0;
    SORT_1 var_205_arg_0 = var_203;
    SORT_1 var_205_arg_1 = var_204;
    SORT_1 var_205 = var_205_arg_0 & var_205_arg_1;
    SORT_1 var_206_arg_0 = var_189;
    SORT_1 var_206_arg_1 = var_205;
    SORT_1 var_206 = var_206_arg_0 | var_206_arg_1;
    SORT_1 var_207_arg_0 = state_13;
    SORT_1 var_207 = ~var_207_arg_0;
    SORT_1 var_208_arg_0 = state_15;
    SORT_1 var_208 = ~var_208_arg_0;
    SORT_1 var_209_arg_0 = var_207;
    SORT_1 var_209_arg_1 = var_208;
    SORT_1 var_209 = var_209_arg_0 & var_209_arg_1;
    SORT_1 var_210_arg_0 = state_17;
    SORT_1 var_210 = ~var_210_arg_0;
    SORT_1 var_211_arg_0 = var_209;
    SORT_1 var_211_arg_1 = var_210;
    SORT_1 var_211 = var_211_arg_0 & var_211_arg_1;
    SORT_1 var_212_arg_0 = state_19;
    SORT_1 var_212 = ~var_212_arg_0;
    SORT_1 var_213_arg_0 = var_211;
    SORT_1 var_213_arg_1 = var_212;
    SORT_1 var_213 = var_213_arg_0 & var_213_arg_1;
    SORT_1 var_214_arg_0 = state_21;
    SORT_1 var_214 = ~var_214_arg_0;
    SORT_1 var_215_arg_0 = var_213;
    SORT_1 var_215_arg_1 = var_214;
    SORT_1 var_215 = var_215_arg_0 & var_215_arg_1;
    SORT_1 var_216_arg_0 = state_23;
    SORT_1 var_216 = ~var_216_arg_0;
    SORT_1 var_217_arg_0 = var_215;
    SORT_1 var_217_arg_1 = var_216;
    SORT_1 var_217 = var_217_arg_0 & var_217_arg_1;
    SORT_1 var_218_arg_0 = state_25;
    SORT_1 var_218 = ~var_218_arg_0;
    SORT_1 var_219_arg_0 = var_217;
    SORT_1 var_219_arg_1 = var_218;
    SORT_1 var_219 = var_219_arg_0 & var_219_arg_1;
    SORT_1 var_220_arg_0 = state_4;
    SORT_1 var_220 = ~var_220_arg_0;
    SORT_1 var_221_arg_0 = var_219;
    SORT_1 var_221_arg_1 = var_220;
    SORT_1 var_221 = var_221_arg_0 & var_221_arg_1;
    SORT_1 var_222_arg_0 = var_221;
    SORT_1 var_222_arg_1 = state_27;
    SORT_1 var_222 = var_222_arg_0 & var_222_arg_1;
    SORT_1 var_223_arg_0 = var_206;
    SORT_1 var_223_arg_1 = var_222;
    SORT_1 var_223 = var_223_arg_0 | var_223_arg_1;
    var_223 = var_223 & mask_SORT_1;
    SORT_1 next_224_arg_1 = var_223;
    SORT_31 next_225_arg_1 = state_32;
    SORT_31 var_228_arg_0 = state_32;
    SORT_31 var_228_arg_1 = var_37;
    SORT_1 var_228 = var_228_arg_0 != var_228_arg_1;
    SORT_31 var_227_arg_0 = state_33;
    SORT_31 var_227_arg_1 = var_226;
    SORT_31 var_227 = var_227_arg_0 + var_227_arg_1;
    SORT_1 var_229_arg_0 = var_228;
    SORT_31 var_229_arg_1 = var_227;
    SORT_31 var_229_arg_2 = state_33;
    SORT_31 var_229 = var_229_arg_0 ? var_229_arg_1 : var_229_arg_2;
    SORT_1 var_230_arg_0 = state_17;
    SORT_31 var_230_arg_1 = var_229;
    SORT_31 var_230_arg_2 = state_33;
    SORT_31 var_230 = var_230_arg_0 ? var_230_arg_1 : var_230_arg_2;
    SORT_1 var_231_arg_0 = state_15;
    SORT_31 var_231_arg_1 = state_34;
    SORT_31 var_231_arg_2 = var_230;
    SORT_31 var_231 = var_231_arg_0 ? var_231_arg_1 : var_231_arg_2;
    SORT_1 var_232_arg_0 = state_29;
    SORT_31 var_232_arg_1 = var_231;
    SORT_31 var_232_arg_2 = state_33;
    SORT_31 var_232 = var_232_arg_0 ? var_232_arg_1 : var_232_arg_2;
    var_232 = var_232 & mask_SORT_31;
    SORT_31 next_233_arg_1 = var_232;
    SORT_31 next_234_arg_1 = state_34;
    SORT_31 var_235_arg_0 = state_33;
    SORT_31 var_235_arg_1 = state_34;
    SORT_1 var_235 = var_235_arg_0 != var_235_arg_1;
    SORT_1 var_236_arg_0 = var_235;
    SORT_31 var_236_arg_1 = var_37;
    SORT_31 var_236_arg_2 = state_35;
    SORT_31 var_236 = var_236_arg_0 ? var_236_arg_1 : var_236_arg_2;
    SORT_1 var_237_arg_0 = state_23;
    SORT_31 var_237_arg_1 = var_236;
    SORT_31 var_237_arg_2 = state_35;
    SORT_31 var_237 = var_237_arg_0 ? var_237_arg_1 : var_237_arg_2;
    SORT_1 var_238_arg_0 = state_19;
    SORT_31 var_238_arg_1 = var_226;
    SORT_31 var_238_arg_2 = var_237;
    SORT_31 var_238 = var_238_arg_0 ? var_238_arg_1 : var_238_arg_2;
    SORT_1 var_239_arg_0 = state_13;
    SORT_31 var_239_arg_1 = var_37;
    SORT_31 var_239_arg_2 = var_238;
    SORT_31 var_239 = var_239_arg_0 ? var_239_arg_1 : var_239_arg_2;
    SORT_1 var_240_arg_0 = state_29;
    SORT_31 var_240_arg_1 = var_239;
    SORT_31 var_240_arg_2 = state_35;
    SORT_31 var_240 = var_240_arg_0 ? var_240_arg_1 : var_240_arg_2;
    var_240 = var_240 & mask_SORT_31;
    SORT_31 next_241_arg_1 = var_240;
    // Assigning next states ...
    state_4 = next_42_arg_1;
    state_13 = next_44_arg_1;
    state_15 = next_49_arg_1;
    state_17 = next_51_arg_1;
    state_19 = next_55_arg_1;
    state_21 = next_57_arg_1;
    state_23 = next_62_arg_1;
    state_25 = next_66_arg_1;
    state_27 = next_71_arg_1;
    state_29 = next_224_arg_1;
    state_32 = next_225_arg_1;
    state_33 = next_233_arg_1;
    state_34 = next_234_arg_1;
    state_35 = next_241_arg_1;
  }
  return 0;
}
